//============================================================================
//	aisa45s.c
//
//	aISA-A45
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1998/11/11
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//============================================================================
#define	STRICT
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"
#include "aisa45w.h"

//-------------------------------------------------
// aISA-A45̳޳ү
//-------------------------------------------------
#define	WM_AISA_INTERRUPT	0x6000		// 荞݂Ƃ̳޳ү
#define WM_AISA45_EOC		(WM_AISA_INTERRUPT + WM_EOC)
#define WM_AISA45_HALF		(WM_AISA_INTERRUPT + WM_BUFF_HALF_FULL)
#define WM_AISA45_FULL		(WM_AISA_INTERRUPT + WM_BUFF_FULL)
#define WM_AISA45_OVERFLOW	(WM_AISA_INTERRUPT + WM_BUFF_OVERFLOW)
#define WM_AISA45_OVERRUN	(WM_AISA_INTERRUPT + WM_SAMPLING_OVERRUN)
//-------------------------------------------------
// aISA-A45үޥץϸ
//-------------------------------------------------
#define HANDLE_WM_AISA45_EOC(hwnd, wParam, lParam, fn) \
	((fn)((hwnd), (wParam), (lParam)), 0L)
#define HANDLE_WM_AISA45_HALF(hwnd, wParam, lParam, fn) \
	((fn)((hwnd), (wParam), (lParam)), 0L)
#define HANDLE_WM_AISA45_FULL(hwnd, wParam, lParam, fn) \
	((fn)((hwnd), (wParam), (lParam)), 0L)
#define HANDLE_WM_AISA45_OVERFLOW(hwnd, wParam, lParam, fn) \
	((fn)((hwnd), (wParam), (lParam)), 0L)
#define HANDLE_WM_AISA45_OVERRUN(hwnd, wParam, lParam, fn) \
	((fn)((hwnd), (wParam), (lParam)), 0L)
//-------------------------------------------------
// ̑萔
//-------------------------------------------------
const TCHAR szTitle[] = _T("Sample");
const TCHAR szA45[]   = _T("aISA-A45");
WORD	gwLogSlot = AISA45_SLOT_AUTO;
//-------------------------------------------------
// ֐
//-------------------------------------------------
LRESULT CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
static BOOL Cls_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam);
static void Cls_OnSysCommand(HWND hwnd, UINT cmd, int x, int y);
static BOOL Aisa45sCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase);
static BOOL Aisa45sClose(WORD wLogSlot);
static BOOL Aisa45sGetResource(WORD wLogSlot);
static BOOL Aisa45sInPort(WORD wLogSlot);
static BOOL Aisa45sStartSample(WORD wLogSlot);
static BOOL Aisa45sGetData(WORD wLogSlot);
void Cls_OnAisa45Eoi(HWND hwnd, WPARAM wParam, LPARAM lParam);
void Cls_OnAisa45Half(HWND hwnd, WPARAM wParam, LPARAM lParam);
void Cls_OnAisa45Full(HWND hwnd, WPARAM wParam, LPARAM lParam);
void Cls_OnAisa45OverFlow(HWND hwnd, WPARAM wParam, LPARAM lParam);
void Cls_OnAisa45OverRun(HWND hwnd, WPARAM wParam, LPARAM lParam);
static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);
//============================================================================
// Ҳ
//============================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	HWND	hMainDlg;
	MSG		msg;

	hMainDlg = CreateDialog(hInstance, MAKEINTRESOURCE(AisaDlg), NULL, MainWndProc);
	if (NULL != hMainDlg){
		ShowWindow(hMainDlg, nCmdShow);
		UpdateWindow(hMainDlg);
		while (GetMessage(&msg, hMainDlg, 0, 0)){
			if (!IsDialogMessage(hMainDlg,&msg)){
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	else
		msg.wParam = 1;
	return msg.wParam;
}
//============================================================================
// 
//============================================================================
LRESULT CALLBACK MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message){
		HANDLE_MSG(hwnd, WM_INITDIALOG,		Cls_OnInitDialog);
		HANDLE_MSG(hwnd, WM_SYSCOMMAND,		Cls_OnSysCommand);
		HANDLE_MSG(hwnd, WM_AISA45_EOC,		Cls_OnAisa45Eoi);
		HANDLE_MSG(hwnd, WM_AISA45_HALF,	Cls_OnAisa45Half);
		HANDLE_MSG(hwnd, WM_AISA45_FULL,	Cls_OnAisa45Full);
		HANDLE_MSG(hwnd, WM_AISA45_OVERFLOW,Cls_OnAisa45OverFlow);
		HANDLE_MSG(hwnd, WM_AISA45_OVERRUN,	Cls_OnAisa45OverRun);
	}
	return FALSE;
}
//============================================================================
//	۸т̊Jn
//============================================================================
static BOOL Cls_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
	if (Aisa45sCreate(&gwLogSlot, hwnd, WM_AISA_INTERRUPT) == TRUE ){
		if (Aisa45sGetResource(gwLogSlot) == TRUE ){
			if (Aisa45sInPort(gwLogSlot) == TRUE){
				if (Aisa45sStartSample(gwLogSlot) == TRUE)
					return TRUE;
			}
		}
	}
	PostQuitMessage(0);
	return FALSE;
}
//============================================================================
//	۸т̏I
//============================================================================
static void Cls_OnSysCommand(HWND hwnd, UINT cmd, int x, int y)
{
	if (cmd == SC_CLOSE){
		PostQuitMessage(0);
		Aisa45sClose(gwLogSlot);
	}
}
//============================================================================
//	aisa45.dll ̎gp錾gp޲T
//============================================================================
static BOOL Aisa45sCreate(PWORD pwLogSlot, HWND hWnd, UINT uWMBase)
{
	TCHAR	szBuf[256];
	BOOL	Result;
	//-------------------------------------------------
	//	aisa45.dll̎gp錾
	//-------------------------------------------------
	Result = Aisa45wDllOpen();
	if (Result == TRUE){
		//-------------------------------------------------
		//	gp޲TAۯĔԍ\܂
		//-------------------------------------------------
		*pwLogSlot = AISA45_SLOT_AUTO;
		Result = Aisa45wCreate(pwLogSlot, hWnd, uWMBase);
		if (Result == TRUE){
			wsprintf(szBuf,_T("aISA-A45 Created\n\nSlot: %2d"), *pwLogSlot);
			ResultMessage(szBuf);
		}
		else
			Aisa45wDllClose();
	}
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if (Result != TRUE){
		ErrorMessage(AISA45_SLOT_AUTO);
		*pwLogSlot = AISA45_SLOT_AUTO;
	}
	return Result;
}
//============================================================================
//	aISA-A45̎gpJ
//============================================================================
static BOOL Aisa45sClose(WORD wLogSlot)
{
	BOOL  Result = TRUE;
	if (wLogSlot != AISA45_SLOT_AUTO){
		//-------------------------------------------------
		//	aISA-A45̎gpJ
		//-------------------------------------------------
		if (Aisa45wClose(wLogSlot) != TRUE){
			ErrorMessage(AISA45_SLOT_AUTO);
			Result = FALSE;
		}
		//-------------------------------------------------
		//	aisa45.dll ̎gpJ
		//-------------------------------------------------
		if (Aisa45wDllClose() != TRUE){
			MessageBox(NULL, "DLL ̃A[hɎs܂", szTitle, MB_OK + MB_ICONSTOP);
			Result = FALSE;
		}
	}
	return Result;
}
//============================================================================
//	aISA-A45ؿ擾\
//============================================================================
static BOOL Aisa45sGetResource(WORD wLogSlot)
{
	AISA45RESOURCE	Ri;
	DWORD	dwDLLVer, dwDriverVer;
	TCHAR	szBuf[256];
	BOOL	Result;
	//-------------------------------------------------
	//	aISA-A45ؿ擾
	//-------------------------------------------------
	Result = Aisa45wGetResource(wLogSlot, &Ri);
	if (Result == TRUE){
		wsprintf(szBuf, _T("Board Name: %s\n")
						_T("NumPorts  : %2d\n")
						_T("IO Address: %04xH-%04xH\n")
						_T("IRQ : %2d")
						,szA45, Ri.dwIOPortLength[0]
						,Ri.dwIOPortBase[0]
						,Ri.dwIOPortBase[0] + Ri.dwIOPortLength[0] - 1
						,Ri.dwIRQRegisters[0]
		);
		ResultMessage(szBuf);
		//-------------------------------------------------
		//	aISA-A45 DLL,VxDްޮݔԍ擾ƕ\
		//-------------------------------------------------
		Result = Aisa45wGetVersion(&dwDLLVer, &dwDriverVer);
		if (Result == TRUE){
			wsprintf(szBuf, _T("GetVersion\n")
							_T("DLL    Version: %08xH\n")
							_T("Driver Version: %08xH")
							,dwDLLVer, dwDriverVer
			);
			ResultMessage(szBuf);
		}
	}
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if (Result != TRUE)
		ErrorMessage(wLogSlot);
	return Result;
}
//============================================================================
//	aISA-A45߰Ă͂\
//============================================================================
static BOOL Aisa45sInPort(WORD wLogSlot)
{
	int		iBotn;
	BYTE	cbDat;
	TCHAR	szBuf[256];
	BOOL	Result;
	//-------------------------------------------------
	//	aISA-A45߰Ă͂ް\
	//-------------------------------------------------
	do {
  	iBotn = IDNO;
		Result = Aisa45wInPort(wLogSlot, &cbDat);
		if (Result == TRUE){
			wsprintf(szBuf,_T("߰ē\nPort In Data: %02XH\n\nē͂܂"),cbDat);
			iBotn = MessageBox(NULL, szBuf, szTitle, MB_YESNO);
		}
	} while((iBotn == IDYES) && (Result == TRUE));
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if (Result != TRUE)
		ErrorMessage(wLogSlot);
	return Result;
}
//============================================================================
//	aISA-A45A/D͂\
//============================================================================
static BOOL Aisa45sStartSample(WORD wLogSlot)
{
	AISA45MODE	Md;
	BOOL	Result;
	//-------------------------------------------------
	//	ݸӰނݒ肵ݸފJn
	//-------------------------------------------------
	Md.dwMode	= 2;
	Md.dwChFirst= 0;
	Md.dwChLast	= 31;
	Md.cwBuffer	= 32 * 2;
	Md.dwTimer	= 0x14;						//20mSϰ
	Result = Aisa45wSetMode(wLogSlot, &Md);
	if (Result == TRUE)
		Result = Aisa45wStartSampling(wLogSlot);
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if (Result != TRUE)
		ErrorMessage(wLogSlot);
	return Result;
}
//============================================================================
//	aISA-A45A/D͂\
//============================================================================
static BOOL Aisa45sGetData(WORD wLogSlot)
{
	DWORD	cwNumData;
	DWORD	cwNum;
	DWORD	dwStatus;
	PWORD	pwData,pwPtr;
	TCHAR	szBuf[1024];
	int		iBotn;
	BOOL	Result;
	//-------------------------------------------------
	//	ݸސ擾ݸް̈m
	//-------------------------------------------------
	Result = Aisa45wGetSamplingStatus(wLogSlot,&cwNumData,&dwStatus);
	if (Result == TRUE && cwNumData > 0){
		pwData = (PWORD)malloc(cwNumData*2);
		if (NULL != pwData){
			//-------------------------------------------------
			//	ݸް擾ĕ\ް쐬
			//-------------------------------------------------
			Result = Aisa45wGetData(wLogSlot, cwNumData, pwData);
			if (Result == TRUE){
				wsprintf(szBuf,_T("[ A/Dް LogSlot:%d]"),wLogSlot);
				pwPtr = pwData;
			 	for (cwNum=0; cwNum < cwNumData; cwNum++){
					if (0 == (cwNum % 4))
						wsprintf(szBuf,_T("%s\n"),szBuf);
					wsprintf(szBuf,_T("%s\tCH%2d:%03X"),szBuf,cwNum+1,*pwPtr);
					pwPtr++;
				}
				//-------------------------------------------------
				//	ݸް\čē͂邩mF
				//-------------------------------------------------
				wsprintf(szBuf,_T("%s\n\nē͂܂"),szBuf);
				iBotn = MessageBox(NULL, szBuf, szTitle, MB_YESNO);
				if ((iBotn == IDYES) && (Result == TRUE))
					Result = Aisa45sStartSample(wLogSlot);
				else
					PostQuitMessage(0);
			}
			free(pwData);
		}
		else 
			Result = FALSE;
	}
	//-------------------------------------------------
	//	װȂ\
	//-------------------------------------------------
	if (TRUE != Result){
		ErrorMessage(wLogSlot);
		PostQuitMessage(0);
	}
	return Result;
}
//============================================================================
//		EOI 荞үޏ
//============================================================================
void Cls_OnAisa45Eoi(HWND hwnd, WPARAM wParam, LPARAM lParam) 
{
	Aisa45wStopSampling((WORD)wParam);
	Aisa45sGetData((WORD)wParam);
}
//============================================================================
//		Half 荞үޏ
//============================================================================
void Cls_OnAisa45Half(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	Aisa45wStopSampling((WORD)wParam);
	Aisa45sGetData((WORD)wParam);
}
//============================================================================
//		Full 荞үޏ
//============================================================================
void Cls_OnAisa45Full(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	Aisa45wStopSampling((WORD)wParam);
	Aisa45sGetData((WORD)wParam);
}
//============================================================================
//		ޯ̧ް۰ 荞ݔүޏ
//============================================================================
void Cls_OnAisa45OverFlow(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	TCHAR	szBuf[60];
	Aisa45wStopSampling((WORD)wParam);
	wsprintf(szBuf, _T("LogSlot:%d ޯ̧ް۰װ܂"), wParam);
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
	PostQuitMessage(0);
}
//============================================================================
//		ް 荞үޏ
//============================================================================
void Cls_OnAisa45OverRun(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	TCHAR	szBuf[60];
	Aisa45wStopSampling((WORD)wParam);
	wsprintf(szBuf, _T("LogSlot:%d ްݥװ܂"), wParam);
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
	PostQuitMessage(0);
}
//============================================================================
// ʂ\
//============================================================================
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
//============================================================================
// װүނ\
//============================================================================
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa45wGetLastError(wLogSlot);
	TCHAR szBuf[50];

	switch (dwRes){
		case AISA45_ERR_SYSTEM:
			wsprintf(szBuf, _T("System error\n\nError code: %08lxh"), GetLastError());
			break;
		case AISA45_ERR_WRAPDLL:
			wsprintf(szBuf, _T("DLL Load error"));
			break;
		default:
			wsprintf(szBuf, _T("aISA-A45 error\n\nError code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szBuf, szTitle, MB_OK | MB_ICONSTOP);
}
